package com.yaoyicloud.service.impl;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Map;

import com.yaoyicloud.constant.enums.ReportType;
import com.yaoyicloud.service.ReportService;
// import com.yaoyicloud.template.AcademicAssociationReport;
// import com.yaoyicloud.template.FoundationReport;
import com.yaoyicloud.template.PlatformCompanyReport;
import org.springframework.stereotype.Service;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

/**
 * 报告服务
 *
 * @author snows
 * @date 2024/10/12
 */
@Slf4j
@Service
@RequiredArgsConstructor
public class ReportServiceImpl implements ReportService {

    // private final AcademicAssociationReport academicAssociationReport;
    // private final FoundationReport foundationReport;
    private final PlatformCompanyReport platformCompanyReport;


    @Override
    public String createPlusVersionCheckReport(
        ReportType reportType, Map<String, Object> data, byte[] templateBytes, String outputBasePath, Long relationId) throws IOException {

        // 1. 将字节流模版写入临时文件
        File tempTemplateFile = File.createTempFile("template_", ".docx");
        try (FileOutputStream fos = new FileOutputStream(tempTemplateFile)) {
            fos.write(templateBytes);
        }

        switch (reportType) {
            case PLATFORM_COMPANY:
                return platformCompanyReport.exportReport(
                        data,
                        tempTemplateFile.getAbsolutePath(),
                        outputBasePath,
                        relationId
                );
            case ACADEMIC_ASSOCIATIONS:
                // 其他类型处理...
            default:
                throw new UnsupportedOperationException("Unsupported report type: " + reportType);
        }
    }
}
